<template>
  <div class="tree-container">
  <a-tree
    :dropdownStyle="{maxHeight:'200px',overflow:'auto'}"
    :expandedKeys.sync='expandedKeys'
    :selectedKeys='selectedKeys'
    :treeData='treeDataSource'
    checkStrictly
    default-expand-all
    show-icon
    @select='handleTreeSelect'
  >
    <a-icon slot="flag" type="flag" theme="filled" />
    <a-icon slot="switcher" type="switcher" theme="filled"/>
    <a-icon slot="star" type="star" theme="filled"/>
  </a-tree>
  </div>
</template>
<script>
export default {
  name: 'TreeLeft',
  props: ['value'],
  data() {
    return {
      cardLoading: true,
      loading: true,
      treeDataSource: [
        {
          title: '保留字',
          key: '0',
          slots: {
            icon: 'switcher',
          },
          children: [
            {
              title: '关键字',
              key: '0-1',
              slots: {
                icon: 'flag',
              },
              children: [
                { title: 'void', slots: { icon: 'star'},key: 'void' },
                { title: 'bool', key: 'bool', slots: { icon: 'star'} },
                { title: 'int', key: 'int' , slots: { icon: 'star'}},
                { title: 'long', key: 'long' , slots: { icon: 'star'}},
                { title: 'float', key: 'float', slots: { icon: 'star'} },
                { title: 'double', key: 'double' , slots: { icon: 'star'}},
                { title: 'string', key: 'string' , slots: { icon: 'star'}},
                { title: 'DateTime', key: 'DateTime', slots: { icon: 'star'} },
                { title: 'TimeSpan', key: 'TimeSpan' , slots: { icon: 'star'}},
                { title: 'true', key: 'true' , slots: { icon: 'star'}},
                { title: 'false', key: 'false' , slots: { icon: 'star'}},
                { title: 'null', key: 'null' , slots: { icon: 'star'}}
              ]
            },
            {
              title: '控制声明',
              key: '0-2',
              slots: {
                icon: 'flag',
              },
              children: [
                { title: 'if', key: 'if' },
                { title: 'else', key: 'else' },
                { title: 'switch', key: 'switch' },
                { title: 'case', key: 'case' },
                { title: 'default', key: 'default' },
                { title: 'continue', key: 'continue' },
                { title: 'for', key: 'for' },
                { title: 'while', key: 'while' },
                { title: 'do', key: 'do' },
                { title: 'break', key: 'break' },
                { title: 'return', key: 'return' },
                { title: 'new', key: 'new' }
              ]
            },
            {
              title: '运算符',
              key: '0-3',
              slots: {
                icon: 'flag',
              },
              children: [
                { title: '+', key: '+' },
                { title: '-', key: '-' },
                { title: '*', key: '*' },
                { title: '/', key: '/' },
                { title: '%', key: '%' },
                { title: '|', key: '|' },
                { title: '++', key: '++' },
                { title: '+=', key: '+=' },
                { title: '-=', key: '-=' }
              ]
            },
            {
              title: '关系操作符',
              key: '0-4',
              slots: {
                icon: 'flag',
              },
              children: [
                { title: '==', key: '==' },
                { title: '>', key: '>' },
                { title: '<', key: '<' },
                { title: '>=', key: '>=' },
                { title: '<=', key: '<=' },
                { title: '!=', key: '!=' },
                { title: '@', key: '@' }
              ]
            },
            {
              title: '逻辑操作符',
              key: '0-5',
              slots: {
                icon: 'flag',
              },
              children: [
                { title: '&&', key: '&&' },
                { title: '||', key: '||' }
              ]
            },
            {
              title: '全局变量',
              key: '0-6',
              slots: {
                icon: 'flag',
              },
              children: [
                { title: 'Int', key: 'GlobalVariable[x].Int' },
                { title: 'Uint', key: 'GlobalVariable[x].Uint' },
                { title: 'Bool', key: 'GlobalVariable[x].Bool' },
                { title: 'Byte', key: 'GlobalVariable[x].Byte' },
                { title: 'Sbyte', key: 'GlobalVariable[x].Sbyte' },
                { title: 'Short', key: 'GlobalVariable[x].Short' },
                { title: 'Ushort', key: 'GlobalVariable[x].Ushort' },
                { title: 'Long', key: 'GlobalVariable[x].Long' },
                { title: 'Ulong', key: 'GlobalVariable[x].Ulong' },
                { title: 'Float', key: 'GlobalVariable[x].Float' },
                { title: 'Double', key: 'GlobalVariable[x].Double' },
                { title: 'String', key: 'GlobalVariable[x].String' },
                { title: 'Object', key: 'GlobalVariable[x].Object' },
                { title: 'DateTime', key: 'GlobalVariable[x].DateTime' },
                { title: 'Decimal', key: 'GlobalVariable[x].Decimal' },
                { title: 'Char', key: 'GlobalVariable[x].Char' },

                { title: 'IntArray[x]', key: 'GlobalVariable[x].IntArray[x]' },
                { title: 'UintArray[x]', key: 'GlobalVariable[x].UintArray[x]' },
                { title: 'BoolArray[x]', key: 'GlobalVariable[x].BoolArray[x]' },
                { title: 'ByteArray[x]', key: 'GlobalVariable[x].ByteArray[x]' },
                { title: 'SbyteArray[x]', key: 'GlobalVariable[x].SbyteArray[x]' },
                { title: 'ShortArray[x]', key: 'GlobalVariable[x].ShortArray[x]' },
                { title: 'UshortArray[x]', key: 'GlobalVariable[x].UshortArray[x]' },
                { title: 'LongArray[x]', key: 'GlobalVariable[x].LongArray[x]' },
                { title: 'UlongArray[x]', key: 'GlobalVariable[x].UlongArray[x]' },
                { title: 'FloatArray[x]', key: 'GlobalVariable[x].FloatArray[x]' },
                { title: 'DoubleArray[x]', key: 'GlobalVariable[x].DoubleArray[x]' },
                { title: 'StringArray[x]', key: 'GlobalVariable[x].StringArray[x]' },
                { title: 'ObjectArray[x]', key: 'GlobalVariable[x].ObjectArray[x]' },
                { title: 'DateTimeArray[x]', key: 'GlobalVariable[x].DateTimeArray[x]' },
                { title: 'DecimalArray[x]', key: 'GlobalVariable[x].DecimalArray[x]' },
                { title: 'CharArray[x]', key: 'GlobalVariable[x].CharArray[x]' }
              ]
            }
          ]
        }
      ],
      selectedKeys: [],
      expandedKeys: ['0','0-1']
    }
  },
  methods: {
    handleTreeSelect(selectedKeys, event) {
      if (!selectedKeys[0].includes('0')) {
        this.$emit('insertTextAtCursor', selectedKeys[0])
      }
    }
  }
}
</script>
<style scoped>
/* 使用深度选择器修改图标颜色 */
::v-deep .ant-tree-iconEle {
  color: #1890FF; /* 修改为你想要的颜色，这里以红色为例 */
}
.tree-container {
  height: 620px;
  overflow: auto;
}
</style>
